"""token.created_at and token.expiration

Revision ID: df896b3ce300
Revises: ac6d38c47cdf
Create Date: 2023-07-27 16:19:49.456925

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "df896b3ce300"
down_revision = "ac6d38c47cdf"
branch_labels = None
depends_on = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column("token", sa.Column("created_at", sa.DateTime(), nullable=True))
    op.add_column("token", sa.Column("expiration", sa.DateTime(), nullable=True))

    from datetime import datetime

    token_table = sa.table(
        "token",
        sa.column("created_at", sa.DateTime()),
        sa.column("expiration", sa.DateTime()),
    )

    op.execute(
        sa.update(token_table)
        .where(token_table.c.created_at == None)
        .values(created_at=datetime.fromtimestamp(0))
    )
    op.execute(
        sa.update(token_table)
        .where(token_table.c.expiration == None)
        .values(expiration=datetime.fromtimestamp(0))
    )

    op.alter_column("token", "created_at", nullable=False)
    op.alter_column("token", "expiration", nullable=False)

    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("token", "expiration")
    op.drop_column("token", "created_at")
    # ### end Alembic commands ###
